// getoptpm.h
// Freeware version. It is distributed without any warranty.

#ifndef GETOPTPM_H
#define GETOPTPM_H

/*
Derived from getopt.c from simtel:pub/msdos/laser/ljsetup.zip
(for the new version see ftp.muni.cz:pub/muni.cz/physics/prog/pm4hp.zip;
this is a program to set up the Hewlett-Packard (tested on LaserJet and
DeskJet) printers from a command line of your computer)
by Petr Mikulik (mikulik@sci.muni.cz, http://www.sci.muni.cz/~mikulik/)
Last change:	 14.12.1996 (4 args)
Previous change: 10.10.1995

It works like the usual getopt. In addition, up to 3 parameters can be
associated with one option:
  -  for an option with 2 parameters: using ";" instead of ":" in the optionS
  -  for an option with 3 parameters: using "!" instead of ":" in the optionS
  -  for an option with 4 parameters: using "_" instead of ":" in the optionS

Example:
"ab:c;d!e_" => myprog -a -b "Hello, world" -c 1 2 -d 1 2 3 4 -e 0.1 2 0.3 4 0.5
               myprog /?

This code is in public domain.
*/


extern int  optind;   /* index into argv array */
extern int  opterr;   /* allow error message */
extern int  optopt;   /* character checked for validity */
extern char *optarg;  /* the 1st argument associated with option */
extern char *optarg2; /* the 2nd argument associated with option */
extern char *optarg3; /* the 3rd argument associated with option */
extern char *optarg4; /* the 4th argument associated with option */
// Oh, now I see that the current+nth arguments can be managed as
// argcv[optind-n] ...
extern char *optplace;/* option letter processing */

#define PMGETOPT_SW "-/"      // options can be  -? /?

#define PMGETOPT_BADCH	'\x0'  // returns this if there was bad character or error


signed char pmgetopt ( int argc, char **argv, char *optionS );

#endif

// eof getoptpm.h

