// lfstream.cpp
// c Petr Mikulik - 1994/1996/1999/2003

#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <iostream.h>
#ifdef __TURBOC__
  #include <process.h>
#endif
#include "ansicpp.h"
#include "pmmath.h"
#include "lfstream.h"
#include "pmruzne.h"


char lfstream_space_after_number = 0;


#define orBAD
/*
To do nothing! Sakra, SGI C++ and DEC C++ defines it
otherwise than the manual says! These bloody commercial
software programmers do not mention fail() and bad()
difference ?!   :-((
Otherwise it should be:
#define orBAD || bad()
*/


void lfstream::lfexit ( int i )
{
last_error = i;
if (can_exit) exit(i);
}


void lfstream::CannotOpen ( const char *what )
{
last_error = 0;
if (fail())
  { cerr <<"\nCannot open file " <<what <<" !\n"; lfexit(1); };
}


void lfstream::open ( char *InputFile )
{
last_error = 0;
line = 1;
inputPipe = NULL;
if ( !strcmp(InputFile,"-") ) {	// read from standard input
  attach( fileno(stdin) );
  return;
  }
#ifdef PIPES
if ( *InputFile=='<' && pipes_avail() ) { // open from a pipe
  inputPipe = popen( InputFile+1, "rb" );
  if (inputPipe==NULL) {
    // but it seems that NULL is never launched. Why?
    cerr <<"Cannot open pipe " <<InputFile <<endl;
    lfexit(1); return; }
  attach( fileno(inputPipe) );
  return;
  }

// Reading from a file. If it is .gz, then decompress it on fly via pipe
if (!FileExist(InputFile)) {
  cerr <<"File " <<InputFile <<" does not exist!\n";
  lfexit(1); return; }
char *pt = strrchr( InputFile, '.' );
if ( pt && !strcmp(pt,".gz") ) {
  if (!pipes_avail()) {
    cerr <<"Cannot decompress input" <<" --- pipes are not available on your system!\n";
    lfexit(1); return; }
  char s[255] = "gzip -d -c ";
  strcat( s, InputFile );
  inputPipe = popen( s, "rb" );
  if (inputPipe==NULL) {
    cerr <<"Cannot open gzip\n";
    lfexit(1); return; }
  attach( fileno(inputPipe) );
  if (fail()) cerr <<" Failed to open!\n";
  return;
  }
#endif
// finally, open an ordinary file
open_normalfile( InputFile );
}


void lfstream::ligno ()
{
last_error = 0;
if (fail()) { errorline(); return; }
if (!eoln_skipspaces()) {
  char c; get(c);
  // if (fail()) { errorline(); return; } // BCPP problem?
  if (!strchr(LFSTREAM_SKIP_LINE,c)) {
    errorline("Extra parameter given (del it or comment it)");
    return; }
  }
 ignore(32535,'\n'); line++;
}

/*
void lfstream::ligno ()
{
if (fail()) { errorline(); return; }
ignore(32535,'\n'); line++;
}
*/

void lfstream::xligno ()
{
last_error = 0;
if (fail()) { errorline(); return; }
ignore(32535,'\n'); line++;
}


void lfstream::errorline ()
{
cerr <<"There is an ERROR on line " <<line <<" !\n";
lfexit(1);
}


void lfstream::errorline ( const char *what )
{
cerr <<what <<" [ line " <<line <<" ]\n";
lfexit(1);
}


void lfstream::print_Error_on_line ( const char *what1, const char *what2, const char *what3 )
{
cerr <<"ERROR on line " <<line;
if (what1) cerr <<what1;
if (what2) cerr <<what2;
if (what3) cerr <<what3;
}


void lfstream::unknown ( const char *what )
{
cerr <<"There is/are UNKNOWN "<<what <<" on line " <<line <<" !\n";
lfexit(1);
}


void lfstream::unknown ( const char *what1, const char *what2 )
{
cerr <<"There is/are UNKNOWN " <<what1 <<' ';
if (*what2=='"') cerr <<what2;
  else cerr <<'"' <<what2 <<'"';
cerr <<" on line " <<line <<" !\n";
lfexit(1);
}


void lfstream::required ( const char *what )
{
cerr <<what <<" required on line " <<line <<" !\n";
lfexit(1);
}


void lfstream::labelrequired ( const char *what )
{
cerr <<"Label \"" <<what <<"\" required before line " <<line <<" !\n";
lfexit(1);
}


void lfstream::labelrequired ( const char *what, const char *found )
{
cerr <<"Label \"" <<what <<"\" required before line " <<line <<" !"
     <<" Encountered \"" <<found <<"\" instead.\n";
lfexit(1);
}


void lfstream::Wrong ( const char *what )
{
cerr <<"Wrong " <<what <<" on line " <<line <<endl;
lfexit(1);
}


void lfstream::Wrong ( const char *what1, const char *what2, const char *what3 )
{
cerr <<"Wrong " <<what1 <<what2 <<what3 <<" on line " <<line <<endl;
lfexit(1);
}


void lfstream::warning ( const char *text )
{
cerr <<"WARNING: " <<text <<" [ line " <<line <<" ]\n";
}


void lfstream::testEnd ()
{
// char S[5]; getline(S, 4, '\n');
last_error = 0;
char S[128]; operator>>(S);
if (fail() || strcmp(strupr(S),"END"))
  { cerr << "END required on line "<<line<<" !\n"; lfexit(1); };
}


void lfstream::LabelRequired ( char *buffer, const char *label )
{
last_error = 0;
operator>>(buffer);
if (strcmp(label,buffer)) labelrequired(label,buffer);
}


void lfstream::skipspaces()
{
char C;
last_error = 0;
do { get(C); if (eof() orBAD) return;
    if (C=='\n') { line++; continue; }
    // if (C==0x0D || C==0x0A)    or C=='\n'
    }
while (isspace(C));
putback(C);
}


void lfstream::skipSpacesAndComments()
{
char C;
last_error = 0;
while (!eof() orBAD) {
  skipspaces();
  if (eof()) return;
  if (!strchr(LFSTREAM_SKIP_LINE,peek())) return;
  // skip line line with comment
  ignore(32535,'\n'); line++;
  }
}


int lfstream::eoln_skipspaces()
{
char C;
last_error = 0;
do { get(C); if (eof() orBAD) return 0;
    if (C=='\n') { putback(C); return 1; } }
while (isspace(C));
putback(C);
return 0;
}


int lfstream::eof_skipspaces()
{
// char C;
// do { get(C); if (eof() orBAD) return 1; } while (isspace(C));
// putback(C);
// return 0;
last_error = 0;
skipspaces();
return eof();
}


double lfstream::degsecrad (char *S)
{
last_error = 0;
operator>>(S);
if (!strcmp(S,"deg")) return deg2rad; else
if (!strcmp(S,"sec")) return sec2rad; else
if (strcmp(S,"rad"))  unknown("angular unit");
return 1;
}


double lfstream::length2m (char *S)
{
last_error = 0;
operator>>(S);
if (!strcmp(S,"cm")) return 0.01; else
if (!strcmp(S,"mm")) return 0.001; else
if (!strcmp(S,"nm")) return 1e-9; else
if (!strcmp(S,"A")) return 1e-10; else
if (!strcmp(S,"km")) return 1e3; else
if (strcmp(S,"m"))  unknown("length unit");
return 1;
}


#define OPERINP(Type,Name,Format)               \
lfstream & lfstream::operator >> (Type &a)      \
{                                               \
last_error = 0;                                 \
skipspaces();                                   \
if (eof()) { errorline(); return *this; }       \
while (!ifstream::operator >> (a)) {            \
  if (eof() orBAD) { errorline(); return *this; } \
  clear();                                      \
  if (!strchr(LFSTREAM_SKIP_LINE,peek()))       \
	{                                       \
	char S[255]; operator>>(S);             \
	cerr <<"ERROR on line " <<line <<": found string \"" <<S \
	     <<"\" instead of " Name "\n";      \
	lfexit(1); return *this;                \
	}                                       \
  clear(); ignore(32535,'\n'); line++;          \
  skipspaces();                                 \
  }                                             \
if (eof() || !space_after_number) return *this; \
char cc = peek();                               \
if (!isspace(cc) && !strchr(LFSTREAM_SKIP_LINE,cc)) { \
   char S[255]; operator>>(S);                  \
   char A[255];                                 \
   sprintf(A,"number \"" Format "%s\" (%s required)",a,S,Name); \
   Wrong(A);                                    \
   lfexit(1); return *this;                     \
   }                                            \
return *this;                                   \
}

OPERINP(int,"integer number","%i")
OPERINP(unsigned int,"integer number","%ui")
OPERINP(long,"integer number","%li")
OPERINP(unsigned long,"integer number","%lu")
OPERINP(float,"real number","%g")
OPERINP(double,"real number","%g")
#undef OPERINP


#ifndef GNU_LIBSTD_3
#define OPERINP(x)					\
lfstream & lfstream::operator >> (x &a)			\
{							\
last_error = 0;			   			\
if (eof()) { errorline(); return *this; }     		\
while(1) { skipspaces(); ifstream::get(a);	\
     if (fail()) { errorline();	return *this; }		\
     if (a=='\n') line++;				\
     if (!strchr(LFSTREAM_SKIP_LINE,a)) return *this;	\
     ignore(32535,'\n'); line++;  }			\
}
#else
#define OPERINP(x)					\
lfstream & lfstream::operator >> (x &a)			\
{							\
last_error = 0;			   			\
if (eof()) { errorline(); return *this; }     		\
while(1) { skipspaces(); a=(x)ifstream::get();		\
     if (fail()) { errorline();	return *this; }		\
     if (a=='\n') line++;				\
     if (!strchr(LFSTREAM_SKIP_LINE,a)) return *this;	\
     ignore(32535,'\n'); line++;  }			\
}
#endif


#ifndef GNU_LIBSTD_3
OPERINP(char)
OPERINP(unsigned char)
#else
OPERINP(char)
OPERINP(signed char)
OPERINP(unsigned char)
    // no idea why it's bothering without "signed"...
#endif
#undef OPERINP


lfstream & lfstream::operator >> (char *a)
{
last_error = 0;
if (eof()) { errorline(); return *this; }
#ifdef GNU_LIBSTD_3 
ifstream *iff = static_cast<ifstream*>(this);
#endif
while(1) {
     skipspaces();
#ifndef GNU_LIBSTD_3 
     ifstream::operator>>(a);
#else
     // crazy... no idea why stdlib has changed so much...
     *iff >> a;
#endif
     if (fail()) { errorline(); return *this; }
     if ((a=="") || !strchr(LFSTREAM_SKIP_LINE,a[0]))
       return *this;
     ignore(32535,'\n'); line++;  }
}


char lfstream::readYesNo ( char *buffer )
{
last_error = 0;
operator>>(buffer);
if (!buffer[1]) { // only 1 char must be read
  if (strchr("0nN",buffer[0])) return 0;
  if (strchr("1yY",buffer[0])) return 1;
  }
required("0,n,N or 1,y,Y");
return 255;
}


int lfstream::readStringWithSpaces ( char *S, int max_len )
{
last_error = 0;
char c;
operator>>(c);
if (c!='"') {
  putback(c);
  operator>>(S);
  return 0; }
// it is a string beginning with "
char *s = S;
char last = *s = 0;
int len = 1;
while (1) {
  get(c);
  if (c=='\n' || eof()) return 2;
  if (c=='"' && last!='\\') return 0;
  if (c=='"' && last=='\\') { s--; len--; }
  *s++ = last = c;
  *s = 0;
  len++;
  if (len==max_len) return 1;
  }
}


// eof lfstream.cpp
