// pmruzne.cpp

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#if defined(__TURBOC__)
  #include <conio.h>
  #include <process.h>
#endif
#include <fstream.h>
#include "ansicpp.h"
#include "pmruzne.h"


void Press () {
#if defined(__MSDOS__) || defined(__EMX__)
   cout << "Press any key to continue...\n";
   getch();  // this works on both __TURBOC__ and __GNUC__ and __EMX__
#else
   cout << "Press ENTER to continue...\n";
   cin.ignore(32535,'\n');
#endif
}


void PressEnter () {
cout << "Press ENTER to continue...\n";
cin.ignore(32535,'\n');
}


void Warning ( char *text ) { cout <<"WARNING: "<<text<<endl; }


void NotImplemented ( char *what, char do_exit /*=1*/ ) {
cerr << what << " has NOT YET been implemented.\n\t...I'm terribly sorry...\n";
if (do_exit) exit(1);
}



// void NotMemory () { cerr<<"NOT ENOUGH MEMORY !\n"; exit(1); }

char* form ( char* format, double x, char* buffer ) {
// it can be used only once when outputting a real,
// e.g.  out << form("%- 1.8g",x,buffer) <<'\t';
// because the string is temporary stored in buffer
// (you should have sth like  char *buffer; buffer=new char [255];
sprintf(buffer,format,x);
return buffer;
}

/*
char* form ( char* format, double x ) {
// it can be used only once (why?) when outputting a real,
// e.g.  out << form("%- 1.8g",x) <<'\t';
// and accidentally it does not work
char *S; S=new char [255];
sprintf(S,format,x);
delete [] S;
return S;
}
*/

char* form ( char* format, double x ) {
// content of the buffer is overwritten by each call to form,
// so it can be used only once when outputting a real.
// e.g.  out << form("%- 1.8g",x) <<'\t';
static char S[41];
sprintf(S,format,x);
return S;
}

char* strcatchar ( char* s, char c ) {
char *cc=strchr(s,0); *cc++=c; *cc=0; return s;
}


void PathOfFileName ( char *Path, char *FileName, char Slash ) {
  // returns Path of the FileName
  // if Slash==0 then without the last Slash, else with
int index=0, i=0; char *c=FileName;
while (*c) {
  #if defined(__unix) && !defined(__os2)
    if (*c=='/') index=i;
  #else
    if (*c=='\\' || *c=='/') index=i;
  #endif
  i++; c++; }
if (Slash) index++;
for (i=0,c=FileName; i<index; i++)
  Path[i]=*c++;
Path[index]=0;
}


// does the file FileName exist?
char FileExist ( char* FileName ) {
ifstream F; F.open(FileName);
if (!F) return 0;
F.close();
return 1;
}


void PressKeyOrReturn ( ) {
#if (defined(__TURBOC__) && !defined(__STDC__)) || (defined(__MSDOS__) && !defined(__TURBOC__)) || defined(__EMX__)
  cout <<"Press any key to continue...";
  getch(); cout <<'\x0D';
  #if defined(__TURBOC__) && !defined(_Windows)
    delline();
  #endif
#else
  cout <<"Press RETURN to continue..."; cin.ignore(32535,'\n');
#endif
}

char* SecToString ( char* S, double time ) {
int h=int(time/3600); time-=h*3600; int m=int(time/60); 
time-=m*60; sprintf(S,"%02d:%02d:%05.2f",h,m,time); return S;
}

// Dynamicka verze substituce. S se expanduje ci zkracuje podle pozadavku.

void gsub ( char **S, char *What, char *ByWhat ) {
// in the string \||S|, replace all occurencies of \||What| by \||ByWhat|
int lWhat=strlen(What), lByWhat=strlen(ByWhat);
char *currS=*S;
int shorten=0;
int allocated; if (lWhat<lByWhat) allocated=strlen(*S);
//-cout<<"Replacing "<<*S<<"  ....  "<<What<<" by "<<ByWhat<<" [** version]\n";
do {
  currS=strstr(currS,What);
  if (!currS) break; // no more matches
  if (strlen(currS)<lWhat) return;
  if (lWhat==lByWhat) { // no need to change the length of \||S|
    memcpy(currS,ByWhat,lByWhat);
    continue; }
  if (lWhat>lByWhat) {
      memcpy(currS,ByWhat,lByWhat);
      currS+=lByWhat;
      strcpy(currS,currS+lWhat-lByWhat);
      shorten+=lWhat-lByWhat;
      continue;
      }
    else {
      if (allocated<strlen(*S)+lByWhat-lWhat) {
	allocated+=4*(lByWhat-lWhat);
	char *tmp=new char [allocated];
	strcpy(tmp,*S); delete [] *S; currS=tmp+(currS-*S);
	*S=tmp; }
      memmove(currS+lByWhat,currS+lWhat,strlen(currS+lWhat));
      memcpy(currS,ByWhat,lByWhat);
      currS+=lByWhat;
      }
  }
while (1);
if (lWhat==lByWhat) return;
if (lWhat>lByWhat) {
  if (shorten>0) { // shorten the string
    currS=new char [strlen(*S)+1]; strcpy(currS,*S);
    delete [] *S; *S=currS; }
  return;
  }
// \||lWhat<lByWhat|, thus shorten the expanded string
int i=strlen(*S);
if (allocated>i) {
  currS=new char [i+1]; strcpy(currS,*S);
  delete [] *S; *S=currS;
  }
}


// Staticka verze. V S musi byt dostatek misto pro substituci.

void gsub ( char *S, char *What, char *ByWhat ) {
// in the string \||S|, replace all occurencies of \||What| by \||ByWhat|
int lWhat=strlen(What), lByWhat=strlen(ByWhat);
char *currS=S;
cout<<"Replacing "<<S<<"   ....   "<<What<<" by "<<ByWhat<<endl;
do {
  currS=strstr(currS,What);
  if (!currS) return; // no more matches
  if (strlen(currS)<lWhat) return;
  if (lWhat==lByWhat) { // no need to change the length of \||S|
    memcpy(currS,ByWhat,lByWhat);
    continue; }
  if (lWhat>lByWhat) {
      memcpy(currS,ByWhat,lByWhat);
      currS+=lByWhat;
      strcpy(currS,currS+lWhat-lByWhat);
//a hodit tam nulu a zapamatovat si, ze se ma string zkratit!!
      continue;
      }
    else {
      memmove(currS+lByWhat,currS+lWhat,strlen(currS+lWhat));
      memcpy(currS,ByWhat,lByWhat);
      currS+=lByWhat;
      }
  }
while (1);
}


// eof pmruzne.cpp

