// theline.cpp
// c Petr Mikulk - 1994

#include <stdlib.h>
#include <string.h>
#include <fstream.h>
#include "ansicpp.h"
#include "lfstream.h"
#include "pmparser.h"


int ThisEveryNth=0, EveryNth=0;
int    ColumnX=1, ColumnY=2, ColumnZ=3, ColumnMax=3;
  // default: the first 3 columns of the data file
char   *FormulaX=NULL, *FormulaY=NULL, *FormulaZ=NULL;
double *TheLine=NULL;


char ReadTheLine
  ( double& X, double& Y, double& Z, lfstream& Inp, unsigned int opt ) {
// it returns 0 if all OK, 1 if new scan, 2 if eof
// option is (additive):
// 0 - no option
// 1 - Not enough columns message; otherwise continue smoothly
// 2 - Detect new scans; otherwise ignore blank lines
if (!TheLine) {
  TheLine=new double [ColumnMax+1];
  if (!TheLine) NotMemory();
  TheLine[0]=0; }
int i;
Again:;
Inp >> TheLine[1];
for (i=2; i<=ColumnMax; i++) {
  if (Inp.eoln_skipspaces())
    if (opt&1) Inp.errorline("not enough columns");
      else {
	Inp.xligno();
	if (opt&2 && Inp.eoln_skipspaces()) return 1; //next scan
	goto Again; } // read next line
  Inp.ifstream::operator>>(TheLine[i]);
  // Inp >> X;  - no, because comments are not allowed
  if (i<ColumnMax && Inp.eof()) return 2;
  if (!Inp) { // wrong line
    if (opt&1) Inp.Wrong("line");
    Inp.clear(); Inp.xligno();
    if (opt&2 && Inp.eoln_skipspaces()) return 1; // next scan
    goto Again; } // read next line
  }
Inp.xligno();
if (--ThisEveryNth>0) { // skip EveryNth-1 points
  if (Inp.eoln_skipspaces() && opt&2) return 1; // next scan
  Inp.skipSpacesAndComments();
  if (Inp.eof()) return 2;
  goto Again; }
if (ColumnX>0) X=TheLine[ColumnX];
  else if (!ColumnX) X=0;
	 else {
	   X=FormulaParserDollars(FormulaX,TheLine,1);
	   if (ParserError) { cout <<"Error ("<<int(ParserError)<<") in formula of "<<'X'<<" column.\n"; exit(1); }
	   }
if (ColumnY>0) Y=TheLine[ColumnY];
  else if (!ColumnY) Y=0;
	 else {
	   Y=FormulaParserDollars(FormulaY,TheLine,1);
	   if (ParserError) { cout <<"Error ("<<int(ParserError)<<") in formula of "<<'Y'<<" column.\n"; exit(1); }
	   }
if (ColumnZ>0) Z=TheLine[ColumnZ];
  else if (!ColumnZ) Z=0;
	 else {
	   Z=FormulaParserDollars(FormulaZ,TheLine,1);
	   if (ParserError) { cout <<"Error ("<<int(ParserError)<<") in formula of "<<'Z'<<" column.\n"; exit(1); }
	   }
ThisEveryNth=EveryNth;
return 0; // ok
}


void ReadColumnsFromInp ( lfstream& Inp, int uptocolumns ) {
char charTmp[256];
Inp >> charTmp; FormulaParserPreProcess(charTmp);
  ColumnX=Formula2Column(charTmp);
  if (ColumnX<0) {
    FormulaX=new char [strlen(charTmp)+1];
    strcpy(FormulaX,charTmp); }
if (uptocolumns<2) ColumnY=0; /*unused*/ else {
Inp >> charTmp; FormulaParserPreProcess(charTmp);
  ColumnY=Formula2Column(charTmp);
  if (ColumnY<0) {
    FormulaY=new char [strlen(charTmp)+1];
    strcpy(FormulaY,charTmp); }
if (uptocolumns<3) ColumnZ=0; /*unused*/ else {
Inp >> charTmp; FormulaParserPreProcess(charTmp);
  ColumnZ=Formula2Column(charTmp);
  if (ColumnZ<0) {
    FormulaZ=new char [strlen(charTmp)+1];
    strcpy(FormulaZ,charTmp); }
} } // over unused formulae
int i;
if (ColumnX<0)
    { i=FormulaParserGetMaxParam(FormulaX);
      ColumnMax = i>ColumnX ? i:ColumnX; }
  else ColumnMax=ColumnX;
if (uptocolumns>1) {
if (ColumnY<0)
    { i=FormulaParserGetMaxParam(FormulaY);
      if (i<ColumnY) i=ColumnY; }
  else i=ColumnY;
if (ColumnMax<i) ColumnMax=i;
if (uptocolumns>2) {
if (ColumnZ<0)
    { i=FormulaParserGetMaxParam(FormulaZ);
      if (i<ColumnZ) i=ColumnZ; }
  else i=ColumnZ;
if (ColumnMax<i) ColumnMax=i;
} }
ThisEveryNth=1;
// not inp.xligno();
}


void ReadColumns123 ( char *one, char *two, char *three,  int uptocolumns ) {
char charTmp[256];
strcpy(charTmp,one); FormulaParserPreProcess(charTmp);
  ColumnX=Formula2Column(charTmp);
  if (ColumnX<0) {
    FormulaX=new char [strlen(charTmp)+1];
    strcpy(FormulaX,charTmp); }
if (uptocolumns<2) ColumnY=0; /*unused*/ else {
strcpy(charTmp,two); FormulaParserPreProcess(charTmp);
  ColumnY=Formula2Column(charTmp);
  if (ColumnY<0) {
    FormulaY=new char [strlen(charTmp)+1];
    strcpy(FormulaY,charTmp); }
if (uptocolumns<3) ColumnZ=0; /*unused*/ else {
strcpy(charTmp,three); FormulaParserPreProcess(charTmp);
  ColumnZ=Formula2Column(charTmp);
  if (ColumnZ<0) {
    FormulaZ=new char [strlen(charTmp)+1];
    strcpy(FormulaZ,charTmp); }
} } // over unused formulae
int i;
if (ColumnX<0)
    { i=FormulaParserGetMaxParam(FormulaX);
      ColumnMax = i>ColumnX ? i:ColumnX; }
  else ColumnMax=ColumnX;
if (uptocolumns>1) {
if (ColumnY<0)
    { i=FormulaParserGetMaxParam(FormulaY);
      if (i<ColumnY) i=ColumnY; }
  else i=ColumnY;
if (ColumnMax<i) ColumnMax=i;
if (uptocolumns>2) {
if (ColumnZ<0)
    { i=FormulaParserGetMaxParam(FormulaZ);
      if (i<ColumnZ) i=ColumnZ; }
  else i=ColumnZ;
if (ColumnMax<i) ColumnMax=i;
} }
ThisEveryNth=1;
// not inp.xligno();
}


void String2Column ( char *formula, int column ) {
char charTmp[256];
strcpy(charTmp,formula); FormulaParserPreProcess(charTmp);
int i=Formula2Column(charTmp);
switch (column) {
  case 1: ColumnX=i;
     if (FormulaX!=NULL) delete(FormulaX);
     if (i<0) {
       FormulaX=new char [strlen(charTmp)+1];
       strcpy(FormulaX,charTmp); }
     break;
  case 2: ColumnY=i;
     if (FormulaY!=NULL) delete(FormulaY);
     if (i<0) {
       FormulaY=new char [strlen(charTmp)+1];
       strcpy(FormulaY,charTmp); }
     break;
  case 3: ColumnZ=i;
     if (FormulaZ!=NULL) delete(FormulaZ);
     if (i<0) {
       FormulaZ=new char [strlen(charTmp)+1];
       strcpy(FormulaZ,charTmp); }
     break;
  }
if (i<0) i=FormulaParserGetMaxParam(charTmp);
if (ColumnMax<i) ColumnMax=i;
ThisEveryNth=1;
}


// eof theline.cpp
