// theline.h: it reads a line from a data file and recalculates
//            the column values according to the formulae given
// (c) Petr Mikulik (mikulik@sci.muni.cz) - 1995
// Freeware version. It is distributed without any warranty.

#ifndef	THELINE_H
#define THELINE_H

#include "ansicpp.h"
#include "lfstream.h"

extern int    ThisEveryNth, EveryNth;
extern int    ColumnX, ColumnY, ColumnZ, ColumnMax;
extern char   *FormulaX, *FormulaY, *FormulaZ;
extern double *TheLine;


char ReadTheLine
  ( double& X, double& Y, double& Z, lfstream& Inp, unsigned int opt );
// it returns 0 if all OK, 1 if new scan, 2 if eof
// option is (additive):
// 0 - no option
// 1 - Not enough columns message; otherwise continue smoothly
// 2 - Detect new scans; otherwise ignore blank lines


void ReadColumnsFromInp ( lfstream& Inp, int uptocolumns );
// reads uptocolumns columns from file Inp

void ReadColumns123 ( char *one, char *two, char *three, int uptocolumns );
// reads uptocolumns columns: one, two (and three if uptocolumns=3)

// for both of the prev. methods:
// intializes all necessary formulae, i.e.
// ColumnX is either positive and the number of column,
//   or -1 and the FormulaX must be used to calculate
//   the column value
// ColumnY and ColumnZ are similar, and they could be 0 if
//   you do not use them if uptocolumns<2 or <3



void String2Column ( char *formula, int column );
// read the column into the formula


#endif

// eof theline.h
